/**
 * Simulates police coordinate an move
 */
public class Police {

    private Land policeLand;
    private int x;
    private int y;


    private boolean notify = false;
    private boolean thiefCatch = false;


    /**
     * Sets first place of police
     * @param x is x coordinate
     * @param y is y coordinate
     */

    public void setFirstxy(int x, int y) {

        this.x = x;
        this.y = y;
    }

    /**
     * random move and then again setting new coordinate
     */
    public void move() {
        Move move1 = new Move(x,y,policeLand);
        move1.moveXY();
        this.x = move1.getX();
        this.y = move1.getY();
    }

    /**
     * Smart move of thief
     * @param w is the thief x coordinate
     * @param z is the thief y coordinate
     */
    public void smartMove(int w,int z) {

        Move move1 = new Move(x,y,w,z,policeLand);
        move1.smartMove();
        this.x = move1.getX();
        this.y = move1.getY();


    }

    /**
     * @param myLand current land
     */
    public void setLand(Land myLand) {
        policeLand = myLand;
    }

    /**
     * @return x coordinate of police
     */

    public int getX() {
        return x;

    }

    /**
     *
     * @return y coordinate of police
     */
    public int getY() {
        return y;
    }

    /**
     * @return true if police notified thief place
     */
    public boolean getNotify() {
        return notify;
    }

    /**
     * @param notify sets field notify true if boolean notify is true
     */
    public void setNotify(boolean notify) {
        this.notify = notify;
    }

    /**
     *
     * @param thiefCatch sets field thiefCatch true if boolean thiefCatch is true
     */

    public void SetThiefCatch(boolean thiefCatch){
        this.thiefCatch = thiefCatch;

    }

    /**
     *
     * @return current situation of thiefCatch returns true if police took the thief
     */
    public boolean getThiefCatch(){
        return thiefCatch;
    }
}
