/**
 * Simulates thief coordinate an move
 */

public class Thief {
    private Land thiefLand;

    private int x ;
    private int y ;


    /**
     * @return x coordinate of thief
     */
    public int getX(){
        return x;

    }

    /**
     *
     * @return y coordinate of thief
     */
    public int getY(){
        return y;
    }

    /**
     *
     * @param myLand current land
     */
    public void setLand(Land myLand) {
        thiefLand = myLand;
    }

    /**
     * Sets first place of thief
     * @param x is x coordinate
     * @param y is y coordinate
     */

    public void setFirstxy(int x,int y) {
        this.x = x;
        this.y = y;

    }

    /**
     * random move and then again setting new coordinate
     */
    public void move() {
       Move move1 = new Move(x,y,thiefLand);
       move1.moveXY();
       this.x = move1.getX();
       this.y = move1.getY();

    }

    /**
     * Smart move of thief
     * @param w is the police x coordinate
     * @param z is the police y coordinate
     */
    public void smartMove(int w,int z) {

        Move move1 = new Move(w,z,x,y,thiefLand);
        move1.smartMove();
        this.x = move1.getW();
        this.y = move1.getZ();


    }

}
